# CNCF Technical Advisory Groups ("TAGs")

The CNCF TOC Technical Advisory Groups scale contributions by the CNCF
technical and user community, while retaining integrity and increasing quality
in support of the [CNCF's mission](https://github.com/cncf/foundation/blob/master/charter.md#1-mission-of-the-cloud-native-computing-foundation).

TOC and TOC Contributors have fulfilled TAG duties in the past and will continue to do so until a specific TAG takes on that responsibility.

## Current TAGS
(In alphabetical order by TAG)
| Name | TOC Liaisons - updated as of 3/31/2024 |
|------|--------------| 
| [TAG App Delivery](https://github.com/cncf/tag-app-delivery) | Katie Gamanji, Lin Sun |
| [TAG Contributor Strategy](https://github.com/cncf/tag-contributor-strategy) |  Dave Zolotusky, Davanum Srinivas, Emily Fox |
| [TAG Environmental Sustainability](https://github.com/cncf/tag-env-sustainability/) | Karena Angell, Kevin Wang, Emily Fox |
| [TAG Network](https://github.com/cncf/tag-network) | Duffie Cooley, Ricardo Rocha, Nikhita Raghunath |
| [TAG Observability](https://github.com/cncf/tag-observability) | Erin Boyd, Ricardo Rocha,  Cathy Zhang |
| [TAG Runtime](https://github.com/cncf/tag-runtime) | Karena Angell, Davanum Srinivas, Cathy Zhang |
| [TAG Security](https://github.com/cncf/tag-security) |  Dave Zolotusky, Duffie Cooley, Lin Sun |
| [TAG Storage](https://github.com/cncf/tag-storage) | Kevin Wang, Nikhita Raghunath |

## TAG Leadership

(Leads in alphabetical order)
<!-- initial refactor update adding chairs and leads form each TAG repo README - Riaan - Dec 2023 -->

### TAG App-Delivery
#### Chairs
| Name                  |
|-----------------------|
| [Lian Li](https://github.com/lianmakesthings) |
| [Roberth Strand](https://github.com/roberthstrand)     |

#### Tech Leads

| Name                  | 
|-----------------------|
| [Sarah Christoff](https://github.com/schristoff)  |
| [Dylan Page](https://github.com/GenPage)    |


### TAG Contributor Strategy
#### Chairs
| Name                  |
|-----------------------|
| [Josh Berkus](https://github.com/jberkus)         |
| [Catherine Paganini](https://github.com/CathPag)  |
| [Dawn Foster](https://github.com/geekygirldawn)   |

#### Tech Leads

| Name                  | Organization           | 
|-----------------------|------------------------|
| [Riaan Kleinhans](https://github.com/Riaankl) |

  
### TAG Environmental Sustainability
#### Chairs
| Name                  |
|-----------------------|
| [Leonard Vincent Simon Pahlke](https://github.com/leonardpahlke)  |
| [Marlow Weston](https://github.com/catblade)                      |
| [Max Körbächer](https://github.com/mkorbi)                        |

#### Tech Leads

| Name                  |
|-----------------------|
| [Cara Delia](https://github.com/caradelia)                |
| [Kristina Devochko](https://github.com/guidemetothemoon)  |


### TAG Network
#### Chairs
| Name                  |
|-----------------------|
| [Lee Calcote](https://github.com/leecalcote)      |
| [Nic Jackson](https://github.com/nicholasjackson) |
| [Zack Butcher](https://github.com/ZackButcher)    |
#### Tech Leads

| Name                  | 
|-----------------------|
| [Zhonghu Xu](https://github.com/hzxuzhonghu)  |


### TAG Observability
#### Chairs
| Name                  |
|-----------------------|
| [Alolita Sharma](https://github.com/alolita)  |
| [Matt Young](https://github.com/halcyondude)  |

#### Tech Leads

| Name                  |
|-----------------------|
| [Bartłomiej Płotka](https://github.com/bwplotka)|


### TAG Runtime 
#### Chairs
| Name                  |
|-----------------------|
| [Danielle Tal](https://github.com/miao0miao)      |
| [Ricardo Aravena](https://github.com/raravena80)  |
| [Stephen Rust](https://github.com/srust)          |

#### Tech Leads

| Name                  |
|-----------------------|
| [Alexander Kanevskiy](https://github.com/kad)         |
| [Klaus Ma](https://github.com/k82cn)                  |
| [Rajas Kakodkar](https://github.com/rajaskakodkar)    |
 

### TAG Security
#### Chairs
| Name                  | Organization            | Term                |
|-----------------------|------------------------|---------------------|
| [Marina Moore](https://github.com/mnm678)          | Independent                  | October, 2023 - October, 2025 | 
| [Eddie Knight](https://github.com/eddie-knight)          | Sonatype               | May, 2024 - May, 2026 | @ |

#### Tech Leads

| Name                  | Organization           | 
|-----------------------|------------------------|
| [Justin Cappos](https://github.com/JustinCappos)       | New York University    |
| [Ash Narkar](https://github.com/ashutosh-narkar)       | Styra                  |
| [Michael Lieberman](https://github.com/mlieberman85)   | Kusari                 | 
| [John Kjell](https://github.com/kjell)                 | TestifySec             | 
| [Marco De Benedictis](https://github.com/mrcdb)        | ControlPlane           |
| [Matt Flannery](https://github.commatthewflannery)     | ThreatCanary           |
| [Brandt Keller](https://github.com/brandtkeller)       | Defense Unicorns       |

### TAG Storage 
#### Chairs
| Name                  |
|-----------------------|
| [Alex Chircop](https://github.com/chira001)               |
| [Raffaele Spazzoli](https://github.com/raffaelespazzoli)  |
| [Xing Yang](https://github.com/xing-yang)                 |

#### Tech Leads

| Name                  |
|-----------------------|
| [Luis Pabon](https://github.com/lpabon)       |
| [Nick Connolly](https://github.com/nconnolly1)|
| [Sheng Yang](https://github.com/yasker)       |


## Emeritus Leaders

We would like to thank to all [past leaders](emeritus_leaders.md) of our TAGs! Your hard work and dedication greatly contributed to this project's success. Your valuable insights shaped our contributor strategy and helped build a strong open-source community. We appreciate all that you've done!"
