# Chair transition checklist

This checklist is borrowed heavily from [TAG Security](https://github.com/cncf/tag-security/blob/main/governance/chair-transition.md) and should be copied into a new issue for when a new chair(s) is needed for any TAG.

## Nomination

New Chairs should be nominated for TOC vote. 

* [ ] Nomination
  * [ ] TOC-Liaison slack discussion and approval
  * [ ] Co-chair & Tech Lead meeting announcement
  * [ ] TAG Meeting announcement -- all regions
  * [ ] TOC email list official nomination
  * [ ] #tag-[InsertTAGHere] slack message with a link to the email nomination
  * [ ] TOC meeting presentation
* [ ] Vote - official count recorded and posted

## Transfer

* [ ] Transfer Logistics
    * [ ] #tag-chairs slack channel - add new chair(s)
    * [ ] tag-chairs mailing list - add new chair(s)
    * [ ] #tag- -cochairs channel - add new chair(s)
    * [ ] #tag-[InsertTAGHere]-cochairs-emeritus - add outgoing chair(s)
    * [ ] #tag-[InsertTAGHere]-toc-liaison - add new chair(s)
    * [ ] Co-chair meeting - add new co-chairs and add doc sharing
    * [ ] transfer ownership of co-chair meeting calendar invite and tech lead calendar invite - if applicable
    * [ ] New meeting link will need created by new calendar owner if using Google meet.  meet.new will create this, just copy into invite or transition to Zoom
* [ ] TOC Liaison meeting
    * [ ] Check if the time still works for new chair(s)
    * [ ] Transfer calender ownership if needed
    * [ ] Add new co-chair(s) to calendar invitation
    * [ ] Share meeting notes doc
* [ ] tag-[InsertTAGHere] repo PR:
    * [ ] Update codeowners, github settings, README (TOC Liaisons and chairs have admin access, tech leads have push access).
    * [ ] Link to official vote email list message in PR descriptions
    * [ ] [TOC Repo update](https://github.com/cncf/toc/tree/main/tags) - submit PR
    * [ ] [Service Desk Access](https://cncfservicedesk.atlassian.net/servicedesk/customer/portal/1)
    * [ ] Update email lists
    * [ ] update email list membership
    * [ ] chairs should have moderator role
    * [ ] remove old chairs from chairs list
    * [ ] Verify new chairs have zoom credentials
    * [ ] YouTube Channel
    * [ ] invite new chairs (if needed)
    * [ ] give "owners" permission

## Announce

* [ ] Announce the vote
  * [ ] #tag-[InsertTAGHere] slack message
  * [ ] email message to the tag-[InsertTAGHere] list

  