# Leadership election process within the `<TAG NAME>`

<!--
This file is a template which can be used by TAGs to bootstrap their governance structure.
Please review this file carefully and make adjustments to better fit your TAG where needed.
-->

The TAG leadership as well as the leadership of working groups or projects follows a common set of rules to ensure a transparent, open and accessible role transition between contributors.
Contributors in leadership positions provide guidance and directions to TAG members and ensure that the efforts are in line with its mission and values, as well as the goals of the TAG.
Roles within the TAG outlining expectations and responsibilities are defined in the [roles](template-roles.md) governance document. <!-- ! UPDATE THE LINK ! -->

## Process of nominations

Leadership roles are open to all interested participants within the community. Depending on the needs of the community, as determined by the current TAG leadership team (Chairs and TLs), nominations may come from working group co-chairs, TAG co-chairs and/or tech leads and/or other community members. Each leadership role is on a 2 year term once appointed.

Elections should be conducted by CNCF staff. TAG leadership Election should start 1-2 months after the TOC election finishes each year, pending CNCF staff’s availability to run the elections.

For the immediate election in 2025, roughly 50% of the roles should be made available for election where existing leaders can choose to rerun, starting with the longest serving leaders. The rest of the leads who are not up for election should plan to be up for elections in 2026.

Co-chairs can be nominated by any existing co-chairs or TOC member. TL roles should be nominated by any existing co-chairs or TLs. WG leads can be nominated by any TAG leaders. TAGs may define their own process by which they field nominations for these roles, provided they adhere to CNCF and TOC expectations of openness, transparency, and accountability.

Co-chair elections should be voted on by the TOC. Other TAG leads elections should be voted by TAG co-chairs, TLs, WG leads or other active contributors of the TAG.

The process of endorsing and selecting individuals will consider the following factors to ensure both the need for proper community representation and the necessary technical expertise: <!-- If the TAG has any additional items, such as leading a minimum number of projects, or facilitating a number meetings, they should be added to this list under "Body of work" -->

* Gender diversity
* Company diversity
* Geo diversity
* Number of nominations from different companies, people, regions for a single individual
* Existing body of work
* Justification provided during nomination

In case there are no individuals expressing interest in taking up leadership positions, an evaluation process for the TAG / working group or project archival may be initiated, as [outlined by the TOC](https://github.com/cncf/toc/blob/main/tags/cncf-tags.md#retirement).

### Leadership election timeline

* **TAG Chair**:
  * Start: CNCF staff initiates election 1-2 months after the TOC election.
  * Nominations: Open for 1-2 months. Co-chairs or TOC members can nominate.
  * Vote: TOC votes.
* **TAG TL**:
  * Start: TAG co-chairs initiate election after the end of the current term.
  * Nominations: Open for 1-2 months. Co-chairs or TLs can nominate.
  * Vote: TAG co-chairs, TLs, WG leads, or other active members of the TAG vote.
* **Working Group Chairs and Leads (WG Chairs, WG TLs)**:
  * Start: TAG co-chairs initiate election after the end of the current term.
  * Nominations: Open for 1-2 months. TAG co-chairs, TLs, WG leads or other active contributors to the TAG can nominate.
  * Vote: TAG co-chairs, TLs, WG leads, or other active members of the TAG vote.

* **Subsequent Steps for Any Role**:
  * Announcement: Communicate the result of the election to the community.
  * Update Resources: Update TAG meeting notes, README files, websites, [repository access](https://github.com/cncf/people/blob/main/config.yaml), and reach out to CNCF staff to share email, Google Drive, and YouTube access if needed.
  * Emeritus: Add the outgoing community leader to the emeritus list and update documents and resources accordingly.

### Submitting a nomination

Nominations are to be submitted to [TAG Co-Chair's email alias](mailto:cncf-tag-chairs@lists.cncf.io) with the details: <!-- ! UPDATE EMAIL with the TAG's Leadership's correct mailing list ! -->

* Subject "NOMINATION $(TAG Chair, TAG TL, WG XYZ Chair): $NAME-OF-NOMINEE"
* CC the nominee
* Justification
* Nominee Biography

### Vacancies

In the event that a TAG lead vacates their seat during their term, a by-election shall be conducted to fill the position for the remainder of the term in accordance with the regular election procedure.
The TAG co-chairs may initiate a vote of no confidence in a TAG leader when the TAG leader has not performed any TAG leader tasks for 6 months. The leader shall be removed if the motion is approved by at least sixty percent (60%) of the TAG leaders along with the approval support from all of the TOC Liaisons for the TAG.

## Nomination requirements

The `<TAG NAME>` recognizes and values the achievements of individuals who have proven themselves in this community.
If a given nominee does not meet all the requirements, the TAG leadership will still review the nomination and justification to determine if enough intent and commitment is present to move forward with an endorsement.

**Nominees must**:

* Be the author of at least one pull request against the `<TAG NAME>` repository
* Be active in the community within the last 3 months before their nomination
  * Active - Attending at least 1 `<TAG NAME>` Regular Meeting a month
  * Engaging in community chat via Slack or lists
  * Commenting on PRs and issues to drive suggestions to proposals, define scope, resolve clarity issues, etc.
* Agree to the nomination

*additional requirements may be defined in the specific [roles](template-roles.md) governance document* <!-- ! UPDATE THE LINK ! -->

**Nominations must**:

* Have justification from the nominator regarding the nominee's capabilities

### Justification for nominees

To ensure nominations are thoughtful and supported, in addition to the above requirements, a justification must enumerate on the nominee's:

* TAG Community involvement
* Leadership and collaboration skills
* Willingness to learn and expand existing technical knowledge
