# $PROJECT Domain Technical Review

v1.0

**Info:** The Domain Technical Review template follows the [General Technical Review questions][gtrq] from the context of the reviewing Technical Advisory Group (TAG) domain. A project may be requested to have multiple domain reviews. For more information, please review [How TAGs Help with Project Reviews and Engagement][pr]. 

**Depending on CNCF maturity application level, not every section may be answered by the reviewing TAG and the TAG review should take no more than an hour of a reviewer's time to complete.**

[gtrq]: general-technical-questions.md
[pr]: project-reviews.md

---

**Project Application Level:** Sandbox/Incubation/Graduation

**Reviewing TAG:** 

**TAG Reviewer(s):** 

**Review Materials:** <presentation to TAG or General Technical Review questionnaire>

**Review Materials URL:** 

**Review Materials Date:** DD-MMM-YYYY 


##  Community and Growth

*Please refer to the TAG Contributor Strategy summary on the project issue. If there are additional considerations TAG Contributor Strategy is not aware of, please include those here.*


<!-- (TAG assertion goes here) -->

##  Day 0 Assessment - Planning Phase

*Please include key highlights of the project’s scope, usability, design, installation and security.* 
* _What gap(s) in the ecosystem does this project fulfill?_ 
* _What, if anything, could make this project better?_
* _Are there any glaring gaps in the design process that the project should consider reviewing?_


<!-- (TAG assertion goes here) -->


##  Day 1 Assessment - Installation and Deployment Phase

Please include key highlights of the project’s installation and deployment:
* _Has this project considered what the project’s installation and configuration looks like?_ 
* _Has the project thought through enablement, rollback, rollout and upgrade planning?_ 
* _Are there any gaps the project’s maintainers should consider to make this project more production ready?_

<!-- (TAG assertion goes here) -->

## Day 2 Assessment - Operations Phase

*Please include key highlights of the project’s day-to-day operations:*
* _Has this project considered adopter scalability and reliability requirements?_
* _Has this project considered how adopters should observe project resources and workloads?_ 
* _Has this project thought through dependencies and lifecycle policies or how to troubleshoot any component failures?_ 
* _Are there any gaps the project should consider?_

<!-- (TAG assertion goes here) -->

## Cloud Native Summary

*Please include key current collaboration as well as potential collaboration opportunities in the cloud native ecosystem, including: TAGs, Working Groups, Kubernetes SIGs, other CNCF projects, and other Foundation projects.*

<!-- (TAG assertion goes here) -->

# TAG Recommendations

## TAG Recommendation to $Project

*Please include steps the project is recommended to take from the TAG’s review of the presentation or General Technical Review questions. Include any gaps or areas of concern along with brief recommendations on how to overcome them.*

<!-- (TAG assertion goes here) -->

## TAG Recommendation to TOC

**Recommendation:** yes/no

**Summary:** 
*Please briefly outline why or why not the TAG leads recommend this project to be admitted to CNCF Sandbox or move levels within the CNCF.*

<!-- (TAG assertion goes here) -->

