# Contributing to the TOC

## Contributing Projects to CNCF

If you're interested in contributing a project to CNCF, please see the full project proposal process is located [here](https://github.com/cncf/toc/blob/main/process/README.md).

## Contributing to Technical Advisory Groups and Working Groups

There has been a call from CNCF’s Technical Oversight Committee (TOC) for contributions to [CNCF TAGs](https://github.com/cncf/toc/blob/main/tags/cncf-tags.md) and [working groups](https://github.com/cncf/toc#working-groups).

Possible ways to contribute:

* Technical content and leadership
* Tech due diligence for projects
* White papers
* Time spent helping projects

## Getting involved in the TOC itself

We use the [cncf/toc](https://github.com/cncf/toc/) github repository to track ongoing work and discussions. Please see our [README.md](https://github.com/cncf/toc#readme) for all the communication channels. We welcome the community to join us in our public meetings as well.

This is not only about individual contribution.  It is also about rallying help from your employer, e.g., if you work for a CNCF Member company. Given the [breadth](https://landscape.cncf.io/) of projects represented by cloud native, it is impossible for anyone to be an expert in all technologies that we’re evaluating. We’re particularly interested in Contributors that can act as a focal point for tapping relevant expertise from their organizations and colleagues in order to engage with CNCF discussions in a timely manner.

TOC [meetings](https://github.com/cncf/toc#meeting-time) are only two hours a month, which are mainly taken up with project presentations. While Contributors are welcome to share their views during the meeting, the biggest opportunity is to comment on the TOC [mailing list](https://github.com/cncf/toc#mailing-list), on pull requests representing project applications and in voting.

The TOC welcomes non-binding votes from members of the CNCF community to express their viewpoints.

And, just as the biggest contributors to open source projects often become maintainers, becoming active in TOC and TAG business is one of the best paths to distinguish oneself ahead of TOC [elections](https://github.com/cncf/toc/blob/main/operations/election-schedule.md).
