# CNCF Cloud Native Definition v1.1 #

*Approved by TOC/GB: 2024-02-26*

[العربية](#العربية) (Arabic) | [հայերեն](#հայերեն) (Armenian) | [中文版本](#中文版本) (Chinese) |  [עברית](#עברית) (Hebrew) | [日本語版](#日本語版) (Japanese) | [한국어](#한국어) (Korean) | [Deutsch](#deutsch) (German) | [Español](#español) (Spanish)  
[Français](#français) (French) | [Polski](#polski) (Polish) | [Português Brasileiro](#português-brasileiro) (Portuguese-BR) | [Português de Portugal](#português-de-portugal) (Portuguese-PT) | [Русский](#русский) (Russian) | [Bahasa Indonesia](#bahasa-indonesia) (Indonesian) | [Türkçe](#türkçe) (Turkish) | [Български](#български) (Bulgarian) | [ไทย](#ไทย) (Thai) | [Magyar](#magyar) (Hungarian) | [Hindi](#हिन्दी) (Indian) | [Nederlands](#nederlands) (Dutch) | [Bengali](#বাংলা) (Bangladesh) | [正體中文版本](#正體中文版本) (Traditional Chinese) | [فارسی](#فارسی) (Persian) | മലയാളം (Malayalam) | [Қазақ](#қазақ) (Kazakh)

## Definition

Cloud native practices empower organizations to develop, build, and deploy workloads in computing environments (public, private, hybrid cloud) to meet their organizational needs at scale in a programmatic and repeatable manner. It **is characterized by loosely coupled systems that interoperate in a manner that is secure, resilient, manageable, sustainable, and observable.**

Cloud native technologies and architectures typically consist of some combination  of containers, service meshes, multi-tenancy, microservices, immutable infrastructure, serverless, and declarative APIs — this list is non-exhaustive.

## Benefits of Cloud Native

Combined with robust automation, cloud native practices allow organizations to make high-impact changes frequently, predictably, with minimal toil and clear separation of concerns.

## Focus of CNCF

The Cloud Native Computing Foundation seeks to drive adoption of this paradigm by fostering and sustaining an ecosystem of open source, vendor-neutral projects. We democratize state-of-the-art patterns to make these innovations accessible for everyone.	

<div dir="rtl">

## العربية

تمكّن التقنيات سحابية المصدر المؤسسات من إنشاء تطبيقات قابلة للتطوير و تشغيلها في بيئات حديثة و ديناميكية مثل السحب العامة و الخاصة و الهجينة. يمثل هذا النموذج الحاويات، و شبكات الخدمة، و الخدمات المصغرة، و البنية التحتية غير المستقرة، و واجهات برمجة التطبيقات التعريفية.

و تمكن هذه التقنيات النظم المقرونة بالمرونة و القابلية للاداره و الملاحظة. بالاضافه إلى الاتمته القوية ، فانها تسمح للمهندسين باجراء تغييرات عاليه التاثير بشكل متكرر و متوقع مع الحد الأدنى من الكدح.

تسعى Cloud Native Computing Foundation إلى دفع اعتماد هذا النموذج من خلال تعزيز نظام إيكولوجي ثابت و مفتوح المصدر و محايد من البائعين. اننا نقوم بإضفاء الديمقراطية على أحدث الأنماط لجعل هذه الابتكارات متاحه للجميع.

</div>

## հայերեն

Ամպային բնիկ տեխնոլոգիաները հնարավորություն են տալիս կազմակերպություններին ստեղծել և գործարկել մասշտաբային հավելվածներ ժամանակակից, դինամիկ միջավայրերում, ինչպիսիք են հանրային, մասնավոր և հիբրիդային ամպերը: Կոնտեյներները, սպասարկման ցանցերը, միկրոսերվիսները, անփոփոխ ենթակառուցվածքը և դեկլարատիվ API-ներն այս մոտեցման օրինակն են:

Այս տեխնիկան թույլ է տալիս թույլ միացված համակարգեր, որոնք ճկուն են, կառավարելի և դիտարկելի: Համակցված ամուր ավտոմատացման հետ՝ դրանք ինժեներներին թույլ են տալիս հաճախակի և կանխատեսելի փոփոխություններ կատարել բարձր ազդեցության՝ նվազագույն ջանքերով:

Cloud Native Computing Foundation-ը ձգտում է խթանել այս պարադիգմի ընդունումը՝ խթանելով և պահպանելով բաց կոդով, վաճառողներից չեզոք նախագծերի էկոհամակարգը: Մենք ժողովրդավարացնում ենք ժամանակակից օրինաչափությունները՝ այս նորամուծությունները բոլորի համար հասանելի դարձնելու համար:

## 中文版本：

云原生技术有利于各组织在公有云、私有云和混合云等新型动态环境中，构建和运行可弹性扩展的应用。云原生的代表技术包括容器、服务网格、微服务、不可变基础设施和声明式API。

这些技术能够构建容错性好、易于管理和便于观察的松耦合系统。结合可靠的自动化手段，云原生技术使工程师能够轻松地对系统作出频繁和可预测的重大变更。

云原生计算基金会（CNCF）致力于培育和维护一个厂商中立的开源生态系统，来推广云原生技术。我们通过将最前沿的模式民主化，让这些创新为大众所用。

<div dir="rtl">

## עברית

טכנולוגיות Cloud Native מעודדות ארגונים לבנות ולהפעיל יישומים מדרגיים בסביבות מודרניות ודינמיות כמו עננים ציבוריים, פרטיים והיברידיים. קונטיינרים, רשתות שירות (service meshes), מיקרו-שירותים, תשתית מקובעת, ו-APIs הצהרתיים הם דוגמאות לגישה הזאת.

שיטות אלו מאפשרות צימוד רופף (loose coupling) של מערכות אשר יהיה עמיד, קל לניהול ולפיקוח. בשילוב עם אוטומציה עמידה, שיטות אלו מאפשרות למהנדסים לעשות שינויים משמעותיים באופן תדיר וצפוי במינימום מאמץ.

קרן Cloud Native Computing Foundation שואפת להביא לאימוץ של הגישה הזאת ע"י טיפוח ותחזוק של מערך פרויקטים שאינו מוטה כלפי ספק מסוים (vendor-neutral) ובקוד פתוח. אנחנו רוצים להעביר תבניות חדישות בתהליך דמוקרטי כך שיהיו נגישות לכולם.

</div>

## 日本語版：

クラウドネイティブ技術は、パブリッククラウド、プライベートクラウド、ハイブリッドクラウドなどの近代的でダイナミックな環境において、スケーラブルなアプリケーションを構築および実行するための能力を組織にもたらします。 このアプローチの代表例に、コンテナ、サービスメッシュ、マイクロサービス、イミュータブルインフラストラクチャ、および宣言型APIがあります。

これらの手法により、回復性、管理力、および可観測性のある疎結合システムが実現します。 これらを堅牢な自動化と組み合わせることで、エンジニアはインパクトのある変更を最小限の労力で頻繁かつ予測どおりに行うことができます。

Cloud Native Computing Foundationは、オープンソースでベンダー中立プロジェクトのエコシステムを育成・維持して、このパラダイムの採用を促進したいと考えてます。 私たちは最先端のパターンを民主化し、これらのイノベーションを誰もが利用できるようにします。

## 한국어:

클라우드 네이티브 기술은 조직이 퍼블릭, 프라이빗, 그리고 하이브리드 클라우드와 같은 현대적이고 동적인 환경에서 확장 가능한 애플리케이션을 개발하고 실행할 수 있게 해준다. 컨테이너, 서비스 메쉬, 마이크로서비스, 불변(Immutable) 인프라, 그리고 선언형(Declarative) API가 이러한 접근 방식의 예시들이다.

이 기술은 회복성, 관리 편의성, 가시성을 갖춘 느슨하게 결합된 시스템을 가능하게 한다. 견고한 자동화 기능을 함께 사용하면, 엔지니어는 영향이 큰 변경을 최소한의 노력으로 자주, 예측 가능하게 수행할 수 있다.

Cloud Native Computing Foundation은 벤더 중립적인 오픈 소스 프로젝트 생태계를 육성하고 유지함으로써 해당 패러다임 채택을 촉진한다. 우리 재단은 최신 기술 수준의 패턴을 대중화하여 이런 혁신을 누구나 접근 가능하도록 한다.

## Español:

Las tecnologías “Cloud Native” empoderan a las organizaciones para construir y correr aplicaciones escalables en ambientes dinámicos modernos, como lo son hoy las nubes públicas, privadas o hibridas. Temas como contenedores, mallas de servicios, microservicios, infraestructura inmutable y APIs declarativas son ejemplos de este enfoque.

Estas técnicas permiten crear sistemas de bajo acoplamiento que son resilentes, administrables y observables. Combinado con técnicas de automatización robusta les permite a los ingenieros realizar cambios de alto impacto de manera frecuente y predecible con un mínimo esfuerzo.

La "Cloud Native Computing Foundation" busca impulsar la adopción de este paradigma mediante el fomento y mantenimiento de un ecosistema de proyectos de código abierto y neutro con respecto a los proveedores. Democratizamos los patrones modernos para que estas innovaciones sean accesibles para todos.

## Français:

Les technologies *Cloud Native* permettent aux entreprises de construire et d'exploiter des applications élastiques dans des environnements modernes et dynamiques comme des *clouds* publics, privés ou bien hybrides. Les conteneurs, le maillage de services, les microservices, les infrastructures immuables et les API déclaratives illustrent cette approche.

Ces techniques permettent la mise en œuvre de systèmes faiblement couplés, à la fois résistants, pilotables et observables. Combinés à un robuste système d'automatisation, ils permettent aux ingénieurs de procéder à des modifications impactantes, fréquemment et de façon prévisible avec un minimum de travail.

La *Cloud Native Computing Foundation* cherche à favoriser l'adoption de ce paradigme en encourageant et en soutenant un écosystème de projets *open source* et indépendants. Nous démocratisons l'état de l'art des bonnes pratiques afin de rendre l'innovation accessible à tous.

## Deutsch:

Cloud native Technologien ermöglichen es Unternehmen, skalierbare Anwendungen in modernen, dynamischen Umgebungen zu implementieren und zu betreiben. Dies können öffentliche, private und Hybrid-Clouds sein. Best Practices, wie Container, Service-Meshs, Microservices, immutable Infrastruktur und deklarative APIs, unterstützen diesen Ansatz.

Die zugrundeliegenden Techniken ermöglichen die Umsetzung von entkoppelten Systemen, die belastbar, handhabbar und beobachtbar sind. Kombiniert mit einer robusten Automatisierung können Softwareentwickler mit geringem Aufwand flexibel und schnell auf Änderungen reagieren.

Die Cloud Native Computing Foundation fördert die Akzeptanz dieser Paradigmen durch die Ausgestaltung eines Open Source Ökosystems aus herstellerneutralen Projekten. Wir demokratisieren modernste und innovative Softwareentwicklungs-Patterns, um
diese Innovationen für alle zugänglich zu machen.

## Polski

Technologie **Cloud Native** pozwalają organizacjom tworzyć i wykorzystywać skalowalne aplikacje w nowoczesnych, dynamicznych środowiskach takich jak chmury publiczne, prywatne czy hybrydowe. Przykładami tego podejścia technologicznego są wirtualne kontenery (ang. *containers*), mikrousługi (ang. *microservices*), platformy dla mikrousług (ang. *service mesh*), niezmienna infrastruktura (ang. *immutable infrastructure*) i deklaratywne interfejsy aplikacyjne (ang. *declarative APIs*).

Wymienione technologie umożliwiają współistnienie luźno-powiązanych (ang. *loosely coupled*) systemów, które cechują się wysokim poziomem odporności, zarządzalności i monitorowalności. W powiązaniu z niezawodną automatyzacją pozwalają inżynierom regularnie i przewidywalnie wprowadzać istotne zmiany z minimalnym wysiłkiem.

Intencją **Cloud Native Computing Foundation** jest przyczynienie się do adopcji tego paradygmatu poprzez wspieranie ekosystemu niezależnych projektów open-source. Demokratyzujemy wysokiej klasy wzorce tworzenia wolnego oprogramowania, aby uczynić te innowacje dostępne dla wszystkich.

## Português Brasileiro:

Tecnologias *cloud native* empoderam organizações a construir e executar aplicações escaláveis em ambientes modernos e dinâmicos, tais como nuvens públicas, privadas e híbridas. Contêineres, *service meshes*, microsserviços, infraestrutura imutável e APIs declarativas exemplificam essa abordagem.

Essas técnicas permitem criar sistemas de baixo acoplamento que são resilientes, gerenciáveis e observáveis. Combinadas com automação robusta, elas permitem aos engenheiros fazer mudanças de alto impacto de forma frequente e previsível, com o mínimo de esforço.

A *Cloud Native Computing Foundation* procura impulsionar a adoção desse paradigma fomentando e sustentando um ecossistema de projetos de código aberto e não atrelados a nenhum fornecedor. Nós democratizamos padrões do estado-da-arte para tornar essas inovações acessíveis a todos.

## Português de Portugal:

As tecnologias Cloud Native capacitam as organizações para construir e executar aplicações escaláveis em ambientes modernos e dinâmicos como nuvens públicas, privadas e híbridas. *Containers*, *service meshes*, microserviços, infraestruturas imutáveis e APIs declarativas exemplificam esta abordagem.

Estas técnicas permitem que sistemas pouco acoplados sejam resistentes, gerenciáveis e observáveis que, combinados com automação robusta, permitem aos profissionais que façam mudanças impactantes com frequência e de forma previsível, sem esforço.

A Cloud Native Computing Foundation procura impulsionar a adoção deste paradigma, fomentando e sustentando um ecossistema baseado em *open source* e neutro do ponto de vista de fornecedores. Democratizamos padrões de última geração para tornar essas inovações acessíveis a todos.


## Русский:

Нативные облачные (Cloud native) технологии позволяют организациям создавать и запускать масштабируемые приложения в современных динамических средах, таких как публичные, частные и гибридные облака. Контейнеры, сервисные сита (service meshes), микросервисы, неизменяемая инфраструктура и декларативные API являются примером такого подхода.

Эти техники позволяют слабосвязанным системам быть устойчивыми, управляемыми и под постоянным контролем. В сочетании с надежной автоматизацией они позволяют инженерам часто и предсказуемо вносить значительные изменения с минимальными усилиями.

Cloud Native Computing Foundation ставит целью адаптировать эту парадигму, развивая и поддерживая экосистему проектов, с открытым исходным кодом, независимую от их поставщиков. Мы демократизируем современные модели, чтобы сделать эти инновации доступными для всех.

## Italiano:

Le tecnologie **cloud native** permettono alle organizzazioni di costruire ed eseguire applicazioni scalabili in ambienti moderni e dinamici come cloud pubblici, privati e ibridi. I container, i micro-servizi, le infrastrutture immutabili e le API dichiarative esemplificano questo approccio.

Queste tecniche permettono che sistemi debolmente accoppiati siano resilienti, gestibili e osservabili. Combinati con un sistema robusto di automazione, permettono agli ingegneri di eseguire frequentemente e con minimo sforzo i cambi ad alto impatto

La **Cloud Native Computing Foundation** cerca di favorire l'adozione di questo paradigma incoraggiando e sostenendo un ecosistema di progetti open source e indipendenti dai vendor. Noi democratizziamo le pratiche allo stato dell'arte per rendere queste innovazioni accessibili a tutti.

## Bahasa Indonesia:

Teknologi *cloud native* memperlengkapi organisasi-organisasi untuk membangun dan menjalankan aplikasi-aplikasi yang dapat diskalakan di dalam lingkungan yang modern dan dinamis seperti
layanan *cloud* publik, privat, maupun hibrida. Kontainer, jaringan layanan (*service mesh*), layanan mikro (*microservice*), infrastruktur
yang tidak dapat diubah (*immutable*), dan API-API yang deklaratif merupakan contoh-contoh pendekatan ini.

Teknik-teknik tersebut memungkinkan sistem-sistem yang terhubung secara longgar (*loosely coupled*) yang tahan banting, dapat dikelola, dan dapat dipantau. Dikombinasikan dengan
automasi yang baik, mereka memungkinkan para rekayasawan (*engineer*) untuk membuat perubahan-perubahan yang berdampak besar secara sering dan dapat diprediksi dengan
usaha yang minimal.

**Cloud Native Computing Foundation** berusaha untuk mendorong adopsi paradigma ini dengan membina dan menopang sebuah
ekosistem proyek-proyek yang bersifat sumber terbuka (*open source*) dan tidak memihak vendor tertentu. Kami mendemokratisasi pola-pola terkini agar
inovasi-inovasi ini dapat diakses oleh semua orang.

## Türkçe:

Buluta Yönelik (**Cloud Native**) teknolojiler kuruluşlara kamusal, özel ve karma bulut ortamları gibi devingen, çağdaş ortamlarda ölçeklenebilir uygulamalar oluşturma ve çalıştırma gücü sağlar. Konteynırlar, servis ağları (service mesh),  mikroservisler, değiştirilmez alt yapılar ve bildirimsel API'ler bu yaklaşıma örnek verilebilir.

Bu yöntemler dirençli, yönetilebilir ve gözlemlenebilir gevşek bağlı sistemlerin oluşturulmasını sağlar. Bunlar güçlü bir otomasyonla harmanlandığında, mühendislerin en az çaba ile yüksek etki oluşturan değişimleri sık ve öngörülebilir şekilde yapabilmelerine olanak verir.

**Cloud Native Computing Foundation** açık kaynaklı ve üretici bağımsız bir ekosistemi destekleyerek ve büyüterek bu paradigmanın benimsenmesini amaçlamaktadır. Bu alandaki en son gelişmelerin herkes tarafından ulaşabilabilir olması için çalışır.

## Български:
Технологиите присъщи за облачните услуги(Cloud Native), позволяват на организациите да изградят и оперират скалируеми приложения в модерните и силно динамични среди, като публичните облачни услуги, частни такива и от смесен тип. Контейнерите, мрежовите услуги(service mesh), микро-услугите(microservices), непроменлива(статична) инфраструктура и декларативните Приложно-Програмни Интерфейси(API) подчертават този подход на работа.

Тези технологии позволяват отделните недиректно свързани системи да са устойчиви, управляеми и наблюдаеми. Комбинирано с изпипана автоматизация те позволяват на инженерите да извършват големи промени, често и с предвидимо минимално количество пречки.

Фондацията за Cloud Native Computing цели да постигне приемственост на този подход като насърчава и подкрепя еко-система от софтуер с отворен код и проекти-необвързани неразработвани от конкретна фирма. Ние позволяваме на тези най-съвременни модели да бъдат достъпни от всеки.

## ไทย:
เทคโนโลยีคลาวด์-เนทีฟช่วยทำให้องค์กรต่างๆสามารถสร้างและรันแอปพลิเคชั่นที่สเกลปรับขนาดได้ (scalable) ในสภาพแวดล้อมที่ทันสมัยและมีการเปลี่ยนแปลงอยู่เสมอ เช่น คลาวด์แบบพับลิค (Public) แบบไพรเวท (Private) และแบบไฮบริด (Hybrid) เป็นต้น
โดยมี คอนเทนเนอร์ (Container), เซอร์วิสเมช (Service Mesh), ไมโครเซอร์วิส (microservices), อิมมิวเทเบิลอินฟราสตรัคเจอร์ (immutable infrastructure) และ ดีแคลเรทีพเอพีไอ (declarative APIs) เป็นตัวอย่างของแนวทางนี้

ซึ่งการใช้เทคนิคเหล่านี้จะทำให้ระบบสามารถเชื่อมต่อกันอย่างหลวมๆมีความยืดหยุ่นสูง เสียหายยาก จัดการได้ง่าย ดูแลได้ง่าย
และเมื่อมารวมกับระบบอัตโนมัติที่แข็งแกร่งด้วยนั้น จะช่วยให้วิศวกรสามารถทำการเปลี่ยนแปลงกับระบบที่ส่งผลกระทบสูงได้บ่อยมากขึ้น ใช้แรงงานน้อยลง และคาดการณ์ได้

มูลนิธิ Cloud Native Computing พยายามที่จะผลักดันเพื่อนำกระบวนทัศน์หรือแนวคิดนี้ไปใช้โดยการส่งเสริมและรักษาระบบนิเวศของโอเพ่นซอร์สให้ยั่งยืน
โครงการนี้เป็นโครงการที่เป็นกลางไม่ยึดกับเวนเดอร์หรือผู้ขายต่างๆ โดยเรานำรูปแบบที่ล้ำสมัยให้เป็นประชาธิปไตยเพื่อสร้างนวัตกรรมที่ทุกคนเข้าถึงได้

## Magyar:

A Cloud Native technológiák képessé teszik a szervezeteket arra, hogy skálázható alkalmazásokat hozzanak létre és futtassanak olyan modern és dinamikus környezetekben, mint a nyilvános, privát és hibrid felhők. Ezt a megközelítést olyan technológiák fémjelzik, mint a konténerek, a szolgáltatás-hálók (service mesh), a mikroszervizek, a nem módosítható infrastruktúra (immutable infrastructure), valamint a deklaratív API-k.

Ezek a technológiák lazán csatolt rendszereket eredményeznek, melyek rugalmasak, jól menedzselhetők és könnyen megfigyelhetők. Robusztus automatizációval kombinálva lehetővé teszik a mérnökök számára, hogy gyakran és kiszámíthatóan hajthassanak végre nagy hatással bíró változtatásokat, minimális erőfeszítés mellett.

A **Cloud Native Computing Foundation** nyílt forráskódú és szolgáltató-semleges projektek támogatása és fenntartása mentén arra törekszik, hogy ösztönözze a Cloud Native paradigma átvételét. Célunk a legmodernebb minták demokratizálása annak érdekében, hogy ezek az innovációk mindenki számára elérhetők legyenek.

## हिन्दी:

क्लाउड नेटिव प्रौद्योगिकियां संगठनों को सार्वजनिक, निजी और हाइब्रिड क्लाउड जैसे आधुनिक, गतिशील वातावरण में स्केलेबल एप्लिकेशन बनाने और चलाने के लिए सशक्त बनाती हैं। कंटेनर, सर्विस मेश, माइक्रोसर्विसेज, अपरिवर्तनीय इन्फ्रास्ट्रक्चर और डिक्लेरेटिव एपीआई इस दृष्टिकोण का उदाहरण हैं।

ये तकनीक ढीले युग्मित सिस्टम को सक्षम करती हैं जो लचीला, प्रबंधनीय और अवलोकन योग्य हैं। मजबूत स्वचालन के साथ, वे इंजीनियरों को न्यूनतम परिश्रम के साथ बार-बार और अनुमानित रूप से उच्च-प्रभाव वाले परिवर्तन करने की अनुमति देते हैं।

क्लाउड नेटिव कंप्यूटिंग फाउंडेशन खुले स्रोत, विक्रेता-तटस्थ परियोजनाओं के एक पारिस्थितिकी तंत्र को बढ़ावा देने और बनाए रखने के द्वारा इस प्रतिमान को अपनाने का प्रयास करता है। हम इन नवाचारों को सभी के लिए सुलभ बनाने के लिए अत्याधुनिक पैटर्न का लोकतंत्रीकरण करते हैं।

## Nederlands:

Cloud native technologieën stellen organisaties in staat om schaalbare applicaties te bouwen en te draaien in moderne, dynamische
omgevingen zoals publieke, private en hybride cloud. Containers, service meshes, microservices, immutable infrastructuur en declaratieve APIs illusteren deze aanpak.

Deze technieken maken los-gekoppelde systemen mogelijk, die veerkrachtig, beheersbaar en observeerbaar zijn. Gecombineerd met robuuste automatisering stellen ze software ontwikkelaars in staat om met grote regelmaat veranderingen met hoge impact aan te brengen, op een voorspelbare wijze en met minimale inspanning.

De Cloud Native Computing Foundation stelt zich als doel om de adoptie van dit paradigma te stimuleren door een eco-systeem van open source en vendor-neutrale projecten aan te moedigen en te faciliteren.
Wij democratiseren state-of-the art software ontwikkel patterns, om deze innovaties voor iedereen toegankelijk te maken.

## বাংলা:

ক্লাউড নেটিভ প্রযুক্তি প্রতিষ্ঠানগুলিকে আধুনিক, গতিশীল পদ্ধতিতে স্কেলেবল অ্যাপ্লিকেশন তৈরি এবং চালানোর ক্ষমতা দেয়
পরিবেশ যেমন সরকারী, ব্যক্তিগত, এবং হাইব্রিড মেঘ। কন্টেইনার, সার্ভিস মেশ, মাইক্রোসার্ভিস, অপরিবর্তনীয়
অবকাঠামো, এবং ঘোষণামূলক এপিআই এই পদ্ধতির উদাহরণ দেয়।

এই কৌশলগুলি শিথিলভাবে সংযুক্ত সিস্টেমগুলিকে সক্ষম করে যা স্থিতিস্থাপক, পরিচালনাযোগ্য এবং পর্যবেক্ষণযোগ্য। একত্রে বা মিশ্রিত
শক্তিশালী অটোমেশন, তারা প্রকৌশলীদেরকে ঘন ঘন এবং অনুমানযোগ্যভাবে ন্যূনতম সাথে উচ্চ-প্রভাব পরিবর্তন করতে দেয়
পরিশ্রম

ক্লাউড নেটিভ কম্পিউটিং ফাউন্ডেশন এই দৃষ্টান্তটি গ্রহণ করার চেষ্টা করে
ওপেন সোর্স, বিক্রেতা-নিরপেক্ষ প্রকল্পের বাস্তুতন্ত্র। আমরা এইগুলি তৈরি করার জন্য অত্যাধুনিক নিদর্শনগুলিকে গণতন্ত্রীকরণ করি৷
প্রত্যেকের জন্য অ্যাক্সেসযোগ্য উদ্ভাবন।

## 正體中文版本

### 定義
雲端原生的實踐賦予組織能夠在運算環境中（公有雲、私有雲、混合雲）以規模化、可程式化和可重複的方式開發、構建和部署工作負載，以滿足其組織需求。其特徵為鬆耦合的系統，這些系統以安全、彈性、可管理、可持續和可觀察的方式相互操作。
雲端原生技術和架構通常由容器、服務網格、多租戶、微服務、不可變基礎設施、無伺服器和聲明式 API 等組成——此列表並非全部。

### 雲端原生的益處
搭配穩固的自動化，雲端原生的實踐讓組織以最少的勞動、清楚分離關注點，就能頻繁、可預測地進行重大變更。

### CNCF關注點
雲端原生運算基金會（Cloud Native Computing Foundation）旨在透過培育和維持一個開放原始碼、廠商中立的專案生態系統，以推動此範式的採用。我們將最先進的模式民主化，使這些創新對每個人都可用。

<div dir="rtl">

## فارسی:

شیوه های ابربومی یا کلود نیتیو به سازمانها کمک میکنند تا بتوانند اپلیکیشن های خود را در محیط های محاسبات ابری (عمومی، خصوصی، ترکیبی از عمومی و خصوصی) توسعه، ساخت و گسترش دهند و از این طریق نیازهای سازمانی خود را درمقیاس وسیع به صورت برنامه ریزی شده و قابل تکرار برآورده سازند. مشخصه ویژه این روش حضور سیستمهای مستقلی است که به صورت امن، تاب آور، مدیریت پذیر، پایدار و قابل مشاهده با یکدیگر تعامل دارند.

تکنولوژی ها و معماری های ابربومی معمولاٌ شامل ترکیبی از کانتینرها، سرویس مش ها، مالتی تننسی یا اجاره چندگانه ها، میکروسرویس ها، زیرساخت تغییرناپذیر، سرورلس یا رایانش بدون سرور و ای پی آی های بیانی (declarative APIs) هستند. البته این لیست کامل نیست.

</div>

### മലയാളം:
കമ്പ്യൂട്ടിംഗ് പരിതസ്ഥിതികളിൽ (പൊതു, സ്വകാര്യ, ഹൈബ്രിഡ് ക്ലൗഡ്) വർക്ക്‌ലോഡുകൾ വികസിപ്പിക്കാനും നിർമ്മിക്കാനും വിന്യസിക്കാനും സ്ഥാപനങ്ങളെ പ്രാപ്തരാക്കുന്ന ക്ലൗഡ് നേറ്റീവ് സമീപനങ്ങൾ, പ്രോഗ്രാമാറ്റിക് ആയിട്ടും ആവർത്തിക്കാവുന്നതുമായ രീതിയിൽ അവരുടെ ഓർഗനൈസേഷണൽ ആവശ്യങ്ങൾ സ്കെയിലിൽ നിറവേറ്റുന്നതിന് സഹായിക്കുന്നു. സുരക്ഷിതവും, പ്രതിരോധശേഷിയുള്ളതും, കൈകാര്യം ചെയ്യാവുന്നതും, സുസ്ഥിരവും, നിരീക്ഷിക്കാവുന്നതുമായ രീതിയിൽ പരസ്പരം പ്രവർത്തിക്കുന്ന അയഞ്ഞ കപ്പിൾഡ് സിസ്റ്റങ്ങളാണ് ഇതിന്റെ സവിശേഷത.

ക്ലൗഡ് നേറ്റീവ് സാങ്കേതികവിദ്യകളിലും ആർക്കിടെക്ചറുകളിലും സാധാരണയായി കണ്ടെയ്‌നറുകൾ, സർവീസ് മെഷുകൾ, മൾട്ടി-ടെനൻസി, മൈക്രോസർവീസുകൾ, മാറ്റാനാവാത്ത ഇൻഫ്രാസ്ട്രക്ചർ, സെർവർലെസ്, ഡിക്ലറേറ്റീവ് API-കൾ എന്നിവയുടെ ചില സംയോജനങ്ങൾ അടങ്ങിയിരിക്കുന്നു.

ശക്തമായ ഓട്ടോമേഷനുമായി സംയോജിപ്പിച്ച്, ക്ലൗഡ് നേറ്റീവ് രീതികൾ ഓർഗനൈസേഷനുകളെ കുറഞ്ഞ അധ്വാനത്തോടെയും ആശങ്കകളുടെ വ്യക്തമായ വേർതിരിവോടെയും ഇടയ്ക്കിടെ, പ്രവചനാതീതമായി ഉയർന്ന സ്വാധീനം ചെലുത്തുന്ന മാറ്റങ്ങൾ വരുത്താൻ അനുവദിക്കുന്നു.ഈ നൂതനാശയങ്ങൾ എല്ലാവർക്കും ആക്‌സസ് ചെയ്യാവുന്ന തരത്തിൽ ഓപ്പൺ സോഴ്‌സ്, വെണ്ടർ-ന്യൂട്രൽ പ്രോജക്റ്റുകളുടെ ഒരു ആവാസവ്യവസ്ഥയെ വളർത്തിയെടുക്കുകയും നിലനിർത്തുകയും ചെയ്യുന്നതിലൂടെ. ഈ മാതൃക സ്വീകരിക്കാൻ ക്ലൗഡ് നേറ്റീവ് കമ്പ്യൂട്ടിംഗ് ഫൗണ്ടേഷൻ ശ്രമിക്കുന്നു.


## Қазақ:

Арнайы бұлтты (Cloud Native) технологиялар ұйымдарға жалпыға ортақ, жеке және гибридті бұлттар сияқты заманауи динамикалық ортада масштабталатын қосымшаларды жасауға және іске қосуға мүмкіндік береді. Контейнерлер, сервистік електер (service meshes), микросервистер, өзгертілмейтін инфрақұрылым және декларативті API бұндай тәсілдің мысалы болып табылады.

Бұл техникалар әлсіз байланысқан жүйелердің орнықты, басқарылатын және тұрақты бақылауда болуына мүмкіндік береді. Сенімді автоматтандырумен үйлесімділікте олар инженерлерге аз күш жұмсай отырып, жиі және болжамды түрде елеулі өзгерістер енгізуге мүмкіндік береді.

Cloud Native Computing Foundation бұл парадигманы жобалардың экожүйесін дамыту және қолдау арқылы олардың жеткізушілеріне тәуелсіз ашық бастапқы кодқа бейімдеуді мақсат етеді. Біз бұл инновацияларды баршаға қолжетімді ету үшін заманауи үлгілерді демократияландырамыз.
