# CNCF Technical Oversight Committee (TOC)

The CNCF TOC is the technical governing body of the CNCF. It admits and oversees all projects in the CNCF  and has a mandate to facilitate driving neutral consensus for:
* defining and maintaining the technical vision and [principles](https://github.com/cncf/toc/blob/main/PRINCIPLES.md) for the Cloud Native Computing Foundation,
* approving new projects within the scope of  the CNCF set by the Governing Board (GB), creating  a conceptual architecture for the projects, aligning projects, removing or archiving projects,
* accepting feedback from end user technical advisory board and map to projects,
* aligning interfaces to components under management (code reference implementations before standardizing), and defining common practices to be implemented across CNCF projects, if any.

## TOC Technical Vision
The technical direction of the ecosystem is problem-centric. We encourage and support our projects to solve problems faced by adopters, to build the right ecosystem for innovation and embrace changes in the broader technical landscape. To exercise and increase the expertise within the technical community to compose solutions that stand the test of time.

## Members

* **Alex Chircop**  (term: 2 years - start date: 3/4/2025 - 3/4/2027) [TOC-appointed]
* **Chad Beaudin** (term: 2 years - start date: 3/4/2025 - 3/4/2027) [EndUser-appointed]
* **Davanum Srinivas** (term: 2 years - start date: 2/16/2024 - 2/16/2026) [TOC-appointed]
* **Emily Fox** (term: 2 years - start date: 2/4/2024 - 3/4/2026) [GB-appointed]
* **Faseela K** (term: 2 years 3/4/2025 - 3/4/2027) [GB-appointed]
* **Jeremy Rickard** (term: 2 years - start date: 3/4/2025 - 3/4/2027) [GB-appointed]
* **Karena Angell** (term: 2 years - start date: 3/4/2025 - 3/4/2027) [GB-appointed][TOC Chair]
* **Katie Gamanji** (term: 2 years - start date: 3/18/2022 - 2/4/2026) [GB-appointed]
* **Kevin Wang** (term: 2 years - start date 2/4/2024 - 2/4/2026) [Maintainer-appointed]
* **Lin Sun** (term: 2 years - start date 2/4/2024 - 2/4/2026) [GB-appointed]  
* **Ricardo Rocha** (term: term: 2 years - start date: 2/4/2024 - 2/4/2026) [EndUser-appointed]

## TOC Shadows

* **Kevin Klues** (term: 1 year - start date: 3/4/2025 - 3/4/2026) [TOC-appointed][shadow]
* **Ricardo Aravena** (term: 1 year - start date: 3/4/2025 - 3/4/2026) [GB-appointed][shadow]

Election [schedule](operations/election-schedule.md)

## Projects

See the [current CNCF projects](https://www.cncf.io/projects/) and a description of project maturity levels (Sandbox, Incubating, Graduated).

The CNCF provides a [list of services](https://www.cncf.io/services-for-projects/) for incubating and graduated projects hosted in the foundation. A subset of these services is also available for [Sandbox](https://www.cncf.io/sandbox-projects/) level projects.

Do you want to contribute to a project? We have a [guide](https://contribute.cncf.io/contributors/) to get you started.

If you would like to know more about the project lifecycle we use, we have [outlined the process](https://github.com/cncf/toc/blob/main/process/README.md). If you have any questions or don't know where to start, please open an [issue](https://github.com/cncf/toc/issues).

## Meeting Time

The TOC meets on the 1st and 3rd Tuesday of every month at 8AM PT (USA Pacific Time; [Convert to local time zone](http://www.thetimezoneconverter.com/?t=8:00AM&tz=San%20Francisco)).  

https://zoom.us/j/967220397
Passcode: 77777

Here is a [Google calendar for all public CNCF events](https://goo.gl/eyutah). This calendar is also available on the [CNCF Website](https://www.cncf.io/calendar/)

## Meeting Agenda and Minutes
- [Meeting Agenda and Minutes](https://github.com/cncf/toc/issues?q=is%3Aissue%20label%3Akind%2Fmeeting%20)
- [Archive (2018.10~2024.08) of Meeting Working Doc](https://docs.google.com/document/d/1jpoKT12jf2jTf-2EJSAl4iTdA7Aoj_uiI19qIaECNFc/edit#). This includes minutes from previous meetings.
- [Archive (2016.02~2019.06) of Meeting agenda and presentations](resources/meeting_presentations.md).
- [Archive (2016.04~2018.11) of community presentations](resources/scheduled_presentations.md)
- [CNCF TOC Playlist on YouTube](https://www.youtube.com/playlist?list=PLj6h78yzYM2Mf6GCZzW6CAk6GlZESbemB)

## Mailing List

Public mailing list for the CNCF TOC: cncf-toc@lists.cncf.io

The public mailing archive: https://lists.cncf.io/g/cncf-toc

Details to join this public mailing list: https://lists.cncf.io/mailman/listinfo/cncf-toc

In case you need to reach the CNCF TOC on sensitive issues, please email us at: cncf-private-toc@lists.cncf.io

## Slack

Public CNCF TOC channel: Join the [CNCF slack](https://slack.cncf.io/) and we are reachable at [#toc](https://cloud-native.slack.com/archives/C0MP69YF4).  

## Voting

This is our [voting policy](docs/voting.md). Only TOC members can cast binding votes. (+1 Binding)

## Technical Advisory Groups Being Phased Out

The TOC has approved the formation of [TAGs](./.archive/README.md).
Currently, the following Technical Advisory Groups are active: 

* [TAG-Security](https://github.com/cncf/tag-security)
* [TAG-Storage](https://github.com/cncf/tag-storage) 
* [TAG-App-Delivery](https://github.com/cncf/tag-app-delivery)
* [TAG-Network](https://github.com/cncf/tag-network)
* [TAG-Runtime](https://github.com/cncf/tag-runtime)
* [TAG Contributor Strategy](https://github.com/cncf/tag-contributor-strategy)
* [TAG Observability](https://github.com/cncf/tag-observability)
* [TAG Environmental Sustainability](https://github.com/cncf/tag-env-sustainability)

The current Technical Advisory Groups will be spun down during 2025 and replaced with new Technical Advisory Groups and TOC SubProjects, listed below.

## New Technical Advisory Groups and TOC SubProjects

### New Technical Advisory Groups

* [TAG Developer Experience](./tags/tag-developer-experience/)
* [TAG Infrastructure](./tags/tag-infrastructure/)
* [TAG Operational Resilience](./tags/tag-operational-resilience/)
* [TAG Security and Compliance](./tags/tag-security-and-compliance/)
* [TAG Workloads Foundation](./tags/tag-workloads-foundation/charter.md)

### TOC SubProjects

* [Artificial Intelligence SubProject](./toc_subprojects/artificial-intelligence-subproject)
* [Contributor Strategy SubProject and Advocacy](./toc_subprojects/contributor-strategy-subproject-and-advocacy/)
* [Mentoring SubProject](./toc_subprojects/mentoring-subproject/)
* [Project Reviews SubProject](./toc_subprojects/project-reviews-subproject/)


### Updating TAG or SubProject README files

To modify the README files for individual TAGs or TOC SubProjects, please **do not edit them directly**. Instead, the source of truth for these files is the [`tags.yaml`](https://github.com/cncf/toc/blob/main/tags.yaml) file. To understand the process for updating these READMEs by modifying `tags.yaml`, please refer to the [Updating TOC TAG and SubProject README Files document](./generator/updating-tag-and-toc=subproject-readme-files.md).