# TOC Chair and Vice Chair

This document serves to provide the TOC Chair and vice chair with details on their responsibilities, role, and expectations that are in addition to those of a TOC member.

## Selection and time commitment

The TOC Chair and Vice Chair are members of the TOC that are chosen by each seated TOC to lead and represent the TOC in the execution of it's work. The expected time commitment of a TOC member who is serving as Chair and Vice Chair is roughly **20-25% of their monthly regular work time**, and may be higher or lower depending on existing community and project challenges, activity of the TOC, and other occurrences that may occupy their time (such as serving in an interim capacity on other groups). They should also anticipate travel to conferences and off-sites at least twice a year, with participation and attendance at various meetings during the CNCF flagship conference: KubeCon+CloudNativeCon (KCCN).

When the TOC is fully seated, CNCF staff open an issue on the TOC repo for current TOC members to nominate themselves or others (with concurrence) for the Chair and Vice Chair. If multiple nominations for a given role (Chair or Vice Chair) are received, the selection moves to a vote. Otherwise, the nominated individual for each role is selected due to no other nominees.

## Functions of the Chair

The Chair is expected to perform a variety of functions and can often be thought of as a Team Lead, as such their work relies on the input and support of the TOC to be successful. A list of known functions and their details is below:

* Support onboarding new TOC members as needed
* Facilitate Initiative Planning
* Ensure Liaisons are assigned and engaged for each TAG
* Serve on the Governing Board in the TOC Seat and represent the TOC to the Governing Board
* Co-present CNCF technical strategy at Governing Board strategy sessions
* Verify appropriate workload distribution among the TOC members
* Serve as technical public spokesperson on behalf of CNCF TOC
* Protect TOC time - People like to sign the TOC up for a lot of things, you are responsible for ensuring we’re involved in the things we need to be and which ones are not on us
* Redirect work out of scope of the TOC to the appropriate group (Kubernetes Steering, Governing Board, Code of Conduct Committee, Legal Committee, etc.)
* Meet periodically with CNCF Leadership, CNCF Staff supporting the TOC, and other Foundations' Technical Leadership (as needed to coordinate cross-foundation opportunities and awareness)

## Functions of the Vice Chair

In addition to serving as the Governing Board alternate for the TOC seat, the Vice Chair is expected co-lead and support the TOC by sharing the below functions of the Chair:

* Support onboarding new TOC members as needed
* Facilitate Initiative Planning
* Co-present CNCF technical strategy at Governing Board strategy sessions
* Protect TOC time - People like to sign the TOC up for a lot of things, you are responsible for ensuring we’re involved in the things we need to be and which ones are not on us
* Meet periodically with CNCF Leadership, CNCF Staff supporting the TOC, and other Foundations' Technical Leadership (as needed to coordinate cross-foundation opportunities and awareness)

## Governing Board Meetings

When a new TOC chair is selected, the following governing board meeting the chair provides a brief introduction about themselves, their vision and principles, and provides a "state of the TOC" address. The State of the TOC address identified current activities, challenges, and work planned or unplanned. It may include a roadmap of what the next year of the TOC looks like.

At subsequent GB meetings, the Chair will provide the GB with a status update of the TOC's work. It is recommended these updates be information with links to where interested GB members may participate or engage.

## Other duties as they occur

This is a short doc, while it does contain a fair amount of information on what goes into being the Chair, there is a lot more that is not documented here due to complexity, sensitivity, sporadic nature of the work, or the number of one-off unrelated things that pop-up time and time again. It is strongly recommended that if you are interested in serving as Chair, reach out to past Chairs and ask their experience. Each Chair's experience is very different, now two are alike. As the community grows and evolves, so too does the functions and responsibilities of the chair.

## Support from CNCF Staff

The TOC receives support from the CNCF to offload much of the project management and administrative functions of the TOC.  Support from CNCF includes but is not limited to:

* Ensure notes and actions are documented and issued for TOC meetings with follow-up
* Ensure TOC meetings have a facilitator and agenda
* Coordinate TOC Keynote and panel at KubeCon + CloudNativeCon (KCCN)
* Facilitate status updates and traction on project applications to move levels
