# Adopter Interview Questions

This template provides the **example set of questions** the TOC leverages in conducting adopter interviews for projects seeking to move levels. The TOC may use all, some, additional questions, or a combination thereof. This template may be linked to for scheduling interviews to that adopters know what to expect.

TOC members will summarize responses to the questions asked in a separate, non-public document until the Adopter approves the content. Once approval is received, the summarized content is copied into the Due Diligence document. Linking to the summary is NOT recommended as it may convey identifying information in the history if not properly access controlled which will circumvent anonymity assurances.

## Setting expectations

The intent of these interviews is to ascertain the maturity and adoption of the project by adopters of the project. They may be public or private.

Expectations conveyance with interviewers: “I’ll record raw notes here, then the notes will be cleaned up and shared with you for your review, correction, and final approval. Once approved, they’ll go into $PROJECT’s due diligence document.”

## Questions

1. How long has your organization used the project?

2. What were the main motivations to adopt the project and which key features do you use today?

3. Compared with other products and projects in this space (proprietary and open) what drew you to the project?

4. What is the current level of usage (pre-production, production) and scale?

5. What version of the project is currently in use and what is your update cadence with the project?

6. Can you walk me through what your experience was in either adopting it outright or integrating it with your existing services and applications? What challenges did you experience with the project?

7. Did you find the information in the repo or the project docs valuable to your implementation? If so, where did you find the information and what specifically was useful?

8. Did you need to engage with the community members or maintainers? If so what was the context of the engagement, which communication channels did you use and did it reach an acceptable outcome?

9. Has your implementation of the project provided measurable value? Such as reducing manual activities, faster integrations, supported federation/multi-cloud, ease of use, cost savings, etc.

10. If the project were to be archived now or in the future, what level of difficulty would your organization experience to remove it from your environments? If that were to happen, would you fork and maintain the project to keep functionality, step into a maintainership role within the project, or something else?

11. Is there something you feel that holds the project back from reaching its ultimate potential?

12. In your opinion, what could the project improve?

13. What are the overall strengths of the project?

14. Do you have any future plans regarding the project? More involvement, feature requests, expansion, etc.

### Maturity Level Survey

The following set of questions goes beyond the scope of the specific project adoption.

Their goal is to benefit from having access to CNCF project adopters and survey their understanding of the CNCF project maturity levels and any reliance on their meaning for decision making. This information should allow the TOC to better document maturity levels targeting adopters.

1. Do you feel you have a good understanding on the meaning of each maturity level for CNCF projects?

2. Is there information missing regarding the meaning of each different level?

3. Do you rely on those levels internally in any way, and if yes how?
