# CNCF Project Archiving Process v1.1

Open source projects have a lifecycle and there are times that projects become inactive due to a variety of reasons. There are also cases where a project may no longer want to be supported by the TOC, or the TOC may no longer wish to recommend the use of a project.

## Triggering a Review to Archive 

CNCF TOC may also look at a variety of signals, including but not limited to:
* [CNCF Project health dashboard](https://projecthealth.cncf.io/)
* If the project would currently meet criteria for acceptance to CNCF
* Requests to archive by anyone in the wider CNCF community
* Security posture of the project, in particular speedy reaction to and resolution of vulnerability reports
* Project meetings schedules and notes
* Public mailing list activity
* Adoption stats

Automated systems and the references above can trigger a review by the TOC. For example a project might be very mature and close to feature complete, which would be different from general inactiveness. The archival process itself remains manual with close attention to the details by TOC.

## Archiving Process

This is a multi-step process with ample time for projects, adopters, and community members to react, discuss, and develop improvements. As a result, it may take an unspecified time. CNCF TOC's intent is to be deliberate in understanding the state of the project and if the project wants and can to return to an active state.

The process can be stopped by TOC consensus at any time until a formal vote has been announced.

1. Archival review is triggered (see above).
2. TOC or community member opens an issue inquiring about the health of the project. While there's not fixed timeline, it will be in the order of months.
3. A formal archival request is created in https://github.com/cncf/toc/issues and the issue tracker of the member project, cross-linking both.
4. TOC informs project maintainers and the end user community. This step will usually be delegated to CNCF staff.
5. The TOC will analyze the project health and evaluate the project for archival. Project and community members are encouraged to discuss on the issue.
6. Once enough information has been provided, the TOC will issue a summary statement and announce a final public comment period of two weeks. This period may be extended by TOC as needed.
7. Once the two week final comment period has been reached, a TOC vote is announced; the voting duration is two weeks. A 2/3 majority in favor of archiving is required.

## Archived Status

What does archiving for a CNCF project mean?

* CNCF will no longer provide support for the project via service desk
* CNCF will list the archived project at https://www.cncf.io/archived-projects/
* Trademarks and domain names of archived projects are still hosted by the CNCF and the Linux Foundation
* CNCF can provide services such as documentation updates to help transition users.
* Other CNCF marketing activities will no longer be provided for the project
* The project can not actively advertise being a CNCF project any more, In particular, previous statuses such as Sandbox, Incubating, or Graduated may not be used any more.
* The project is free continue development in its repositories, ideally with a goal to reactivate itself

## Reactivating an Archived Project

Any project can be reactivated into CNCF by following the normal [Project Lifecycle & Process](https://github.com/cncf/toc/tree/main/process#cncf-project-lifecycle--process)
