# Background

[Backstage​​](https://backstage.io/) is an open platform for building developer portals. Powered by a centralized software catalog, Backstage restores order to your microservices and infrastructure and enables product teams to ship high-quality code quickly — without compromising autonomy.

Backstage unifies all your infrastructure tooling, services, and documentation to create a streamlined development environment from end to end and is based upon three core feature sets:

- **[Create](https://backstage.io/blog/2020/08/05/announcing-backstage-software-templates)** - Backstage uses software templates to simplify setup, standardize tooling, and deploy with the click of a button. Using automated templates, engineers can spin up a new microservice, website, or other software component with your organization’s best practices built-in, right from the start.
- **[Manage](https://backstage.io/blog/2020/06/22/backstage-service-catalog-alpha)** - The software catalog is a centralized system that keeps track of ownership and metadata for all the software in your ecosystem (services, websites, libraries, data pipelines, etc). The catalog is built around the concept of metadata yaml files stored together with the code, which are then harvested and visualized in Backstage.
- **[Explore](https://backstage.io/blog/2020/09/08/announcing-tech-docs)**- How to find stuff? Backstage surfaces all the relevant information to users in relation to their components and services. From service metadata through the catalog, tooling to explore and manage through plugins, and documentation available right alongside the code. A single pane of glass to reduce context switching that can be built on with search or other discoverability tools, improving overall productivity and for engineers and users.

## Development metrics

Here are a few highlights from the project's [DevStats Page](https://backstage.devstats.cncf.io/d/8/dashboards) page, looking at the 1 year period of October 2020 through September 2021:

- This year we welcomed [298 new contributors](https://backstage.devstats.cncf.io/d/52/new-contributors-table?orgId=1&from=1601503200000&to=1633125599000) across our repositories.
- The average number of active contributors increased to [74, up from 65](https://backstage.devstats.cncf.io/d/74/contributions-chart?orgId=1&from=1601503200000&to=1633125599000).
- These active contributors come from [269 different companies](https://backstage.devstats.cncf.io/d/5/companies-table?orgId=1&var-period_name=Last%20year&var-metric=contributions), up from 25.
- The activity across repositories shows a clear steady increase.

## Maintainers

- There are a total of 4 maintainers
- 2 additional reviewers
- All maintainers are currently from Spotify

## Other metrics

- Our Github Stars have increased up to 13.5k stars, up from 8k from last year.
- Our Discord community is now up to nearly 4k members.
- Our Backstage Community Meetings have on average 100 participants live, and up to 1.5k views on youtube after the date.

## How many maintainers do you have, and which organisations are they from? (Feel free to link to an existing MAINTAINERS file if appropriate.)

[OWNERS.md](https://github.com/backstage/backstage/blob/master/OWNERS.md)

## What do you know about adoption, and how has this changed since your last review / since you joined Sandbox? If you can list companies that are end users of your project, please do so. (Feel free to link to an existing ADOPTERS file if appropriate.)

The official [ADOPTERS.md](https://github.com/backstage/backstage/blob/master/ADOPTERS.md) list increased from [13](https://github.com/backstage/backstage/blob/992dfd545212f82cdeb83e2fc48921a4faa45e99/ADOPTERS.md) to 60 entries.

## How has the project performed against its goals since the last review? (We won't penalize you if your goals changed for good reasons.)

This is our first annual review, so we didn’t have any goals to focus on from a CNCF perspective, however our major internal focuses as maintainers were as follows:

#### Adoption

- Bring on more companies and more contributors to drive adoption for the project.

#### Community

- Start up Community Sessions as the main mechanism for sharing contributions and efforts adopters have been working on

#### Project API Stability

- Search and Discoverability
- The Software Catalog
- Software Templates

## What are the current goals of the project? For example, are you working on major new features? Or are you concentrating on adoption or documentation?

- Scaling out the maintenance and support for the ever growing list of adopters
- Starting to spin up multiple SIG’s for the different core aspects of Backstage
- Introducing maintainers from different companies and improving diversity across the maintainer list

## How can the CNCF help you achieve your upcoming goals?

### Project Visibility

We’d like to give more talks at conferences like KubeCon and have open office hours during these conferences to really spread the word about Backstage and provide first class support for existing or upcoming adopters. Also having access to the Project Pavilion and having our own booth at these conferences would also help us here.

### Security Reviews

We’d also love to continue the support for Security Reviews to ensure that we are on top of any security vulnerabilities and issues that we might have.

### Educational Content

Support in identifying and producing educational content for Backstage, enabling users to receive backstage training or become Backstage certified

## Do you think that your project meets the criteria for incubation?

Yes, in fact here’s the [Backstage incubation PR](https://github.com/cncf/toc/pull/717)
