**CloudEvents Incubator Proposal**

[CloudEvents](https://cloudevents.io) (CE) is currently a sandbox stage member project. Please refer to the [CE sandbox stage proposal](https://github.com/cncf/toc/pull/133) for details on the previous proposal.

Since entering the CNCF Sandbox in May 2018, CE has released 3 interim versions (v0.1, v0.2, v0.3) as the specification has evolved. With the current plan of approaching a 1.0 version of the specification before the end of 2019. The weekly calls average ~27 people per call with a total of 78 organizations and 4 unaffiliated people participating. The organization list includes:


  Accenture, Adobe, Alibaba, Amazon, Asyncy, Auth0, Bitnami, Camunda, Chegg, Cisco, Clay, CNCF, Codit, Collinson Group, Confluent, ControlBEAM, Cuemby, Denso Automative, Doc.AI, Docker, Enterprise Holdings, Everis, FineDesignGroup, Fujitsu, Galactic Fog, Github, Google, Googlr, Hauwei, Heetch, Home Depot, Honeycomb.io, Huawei, IBM, Intel, Itau Unibanco, JFrog, JP Morgan, JS Foundation, Justin Johnson, Kong, Mastercard, Microsoft, Mosaic 451, NAIC, NATS/Synadia, NGINX, Nordstrom, Okta, OpenFaaS, Oracle, Particular Software, PayPal, Pierre Alexandre Lacerte, Pivotal, Progress, Puppet, PureSec, RSA, RX-M, Red Hat, SAP, SaltStack, Samsung/Joyant, Serverless, Singlepoint, Solace, Solar Winds, Splunk, Streamlio, Trimble Transportation, Twistlock, VMWare, Verizon, commercetools, iguazio, infraCloud, solo.io

In addition there are 5 SDK’s ([CSharp](https://github.com/cloudevents/sdk-csharp), [Go](https://github.com/cloudevents/sdk-go), [Java](https://github.com/cloudevents/sdk-java), [Javascript](https://github.com/cloudevents/sdk-javascript), [Python](https://github.com/cloudevents/sdk-python)) in progress, being actively developed, and in use. For example, the Go SDK is being used directly in the [knative](https://knative.dev/) project.

Deliverables include:



*   [Spec](https://github.com/cloudevents/spec/blob/master/spec.md), Serialization Rules, Transport Bindings,
*   [Primer](https://github.com/cloudevents/spec/blob/master/primer.md), SDKs, [Extensions](https://github.com/cloudevents/spec/blob/master/documented-extensions.md),
*   Demos (madlibs, timeline, airport)

**Supporting Evidence for Incubating Stage**



*   For adoption, these companies have adopted CE into their products:
    *   Microsoft - EventGrid
    *   Serverless.com - Event Gateway
    *   Knative - used within its Eventing framework
    *   IBM, RedHat, Google, Pivotal, etc...
    *   Oracle - Fn
    *   Adobe - I/O Events
    *   Codit
    *   commercetools
    *   RedHat - EventFlow, Eclipse Vert.x, Debezium
    *   SAP - Kyma
    *   Argo-Events
    *   Brigade
*   End users include:
    *   Whitbread
    *   Pandora
    *   Accenture
    *   German Ministry of Migration and Refugees
*   Members with voting rights (as tracked by the [meeting attendance tracker](https://docs.google.com/spreadsheets/d/1bw5s9sC2ggYyAiGJHEk7xm-q2KG6jyrfBy69ifkdmt0/edit?pli=1#gid=0))
    *   Adobe: Roberto Perelman
    *   Google: Scott Nicols
    *   IBM: Doug Davis
    *   Microsoft: Clemens Vasters
    *   NATS/Synadia: Colin Sullivan
    *   PayPal: Jem Day
    *   Red Hat: William Markito Oliveira
    *   RSA: Dan Barker
    *   RX-M: Christian Lacsina
    *   SAP: Klaus Deissner
    *   VMWare: Mark Peek
    *   Self: Vlad Ionescu
    *   Self: Erik Erikson
    *   Self: John Mitchell
*   Project voting rights are dictated by the [CE Governance Policy](https://github.com/cloudevents/spec/blob/master/GOVERNANCE.md)
*   Releases: [https://github.com/cloudevents/spec/releases](https://github.com/cloudevents/spec/releases)
*   Current [Roadmap](https://github.com/cloudevents/spec/blob/master/roadmap.md)
*   Contributors: [https://github.com/cloudevents/spec/graphs/contributors](https://github.com/cloudevents/spec/graphs/contributors)
*   Commit activity: [https://github.com/cloudevents/spec/graphs/commit-activity](https://github.com/cloudevents/spec/graphs/commit-activity)
*   CNCF [devstats dashboard](https://cloudevents.devstats.cncf.io/d/8/dashboards?orgId=1&refresh=15m) and [Community Stats](https://cloudevents.devstats.cncf.io/d/3/stars-and-forks-by-repository?orgId=1) 

The CloudEvents project presented this proposal for incubator status on the September 17, 2019 TOC call - [agenda doc with slides](https://docs.google.com/presentation/d/1igwqeQLR3xzWjNT460lM6Geewy4jSFNbhqfPzkp2VZs/edit?ts=5d5aabb2#slide=id.g25ca91f87f_0_56).
