# 2023 Kuberhealthy Annual Review
<center><img src="https://github.com/kuberhealthy/kuberhealthy/blob/master/images/kuberhealthy.png?raw=true"></center><br />

**Project Page**: https://github.com/orgs/kuberhealthy/repositories

**Devstats Dashboard**: https://kuberhealthy.devstats.cncf.io/d/8/dashboards?orgId=1&refresh=15m

**Docker Hub Images**: https://hub.docker.com/orgs/kuberhealthy/repositories

**Stars**: 1,837

**Forks**: 253

## Active Maintainers 
Currently, I am the primary maintainer (@integrii from @EpicGames (Previously @Comcast)) of Kuberheralthy.  This has been fine due to the relatively low volume of issues and code reviews, but additional contributors should be sought after.  There are other potential contributors to the project that may be interested in the duties of a maintainer, such as @ewassef.

## Contributors

Kuberhealthy has [85 contributors](https://github.com/kuberhealthy/kuberhealthy/graphs/contributors) and still growing!

## Adopters
Kuberhealthy has had trouble growing an official adopters list because companies generally require approval to have their names posted in the project.  The current official adopters include Adobe, Jenkins X, Polarpoint, Meltwater, and Mercedes Benz.  Based on the various GitHub profiles I have seen raising issues and contributing to the project, along with the huge number of image pulls we're getting, I would wager that the actual list of adopters is much, more important.

On the [Docker Hub Images](https://hub.docker.com/orgs/kuberhealthy/repositories) page, you can see that [one check has over 10 million pulls](https://hub.docker.com/orgs/kuberhealthy/repositories) and [many others have over a million pulls](https://hub.docker.com/repository/docker/kuberhealthy/deployment-check).  The main Kuberhealthy controller image [has more than 1M pulls](https://hub.docker.com/repository/docker/kuberhealthy/kuberhealthy).

Keep in mind that the number of pulls does not reflect the number of actual runs because images are cached on the nodes they run on.

## Performance since last review
While no specific goals for growth were set, Kuberhealthy has continued to grow. Here are some stats:

| Metric | 2022  | 2023 |
| ------------- | ------------- | ------------ |
| Issues | 375 | 405  |
| Stars | 1,459 | 1,837  |
| Forks | 208 | 253  |
| Pull Requests | 688 | 754 |
| Contributors | 68 | 85 |
| Image Pulls on kuberhealthy/kuberhealthy | 500k | 1M |

There have been some notable community articles for Kuberhealthy in 2023 as well.  Such as [this one](https://isitobservable.io/observability/kubernetes/what-is-kuberhealthy-and-how-do-you-use-it) from 'Is it Observable?' which includes a 48m long YouTube video on Kuberhealthy.

## Goals
I think it is important to continue working to  increase the number of maintainers on the project, so that I am not the one doing most of the work. I also plan to drive a large release with a lot of merged PRs along with a fresh set of updates to all package dependencies.


## How the CNCF can help
It would be nice if we could have a paid docker hub account.  The existing free account only supports 3 members, and those spots are filled.  More members would mean more people able to cut releases, and that will be important to growth.  Plus, its good to support Docker Hub.

It would also be nice if the CNCF was able to design us an improved logo (ours was basically clip-art) or fund some SWAG for our contributors and official adopters!

If we find ourselves hitting a limit with GitHub actions, some funding to keep that moving would be nice too - but we aren't there yet.

## Incubation
I don't believe Kuberhealthy is ready for incubation yet.  I would like to see the project garner more official adopters, gather some more maintainers, and add a web interface before applying to be promoted.


## Thank You
Having Kuberhealthy adopted into the CNCF has been wonderful for the project!  Thank you again in 2023 for the support!
