# Kubewarden 2023 Annual Review

[Kubewarden](https://www.kubewarden.io/) is a Kubernetes Dynamic Admission
Controller that validates incoming requests against WebAssembly policies. The
policies can be developed in any programming language that generates
WebAssembly binaries.

## DevStats

The Kubewarden devstats page and dashboard
are[here](https://kubewarden.devstats.cncf.io/d/8/dashboards?orgId=1&refresh=15m)

- 54
  [contributors](https://kubewarden.devstats.cncf.io/d/18/overall-project-statistics-table?orgId=1&var-period_name=Last%20year&var-repogroup_name=All)
  in the last year
- 875
  [PRs](https://kubewarden.devstats.cncf.io/d/18/overall-project-statistics-table?orgId=1&var-period_name=Last%20year&var-repogroup_name=All)
  in the last year
- 548
  [issues](https://kubewarden.devstats.cncf.io/d/18/overall-project-statistics-table?orgId=1&var-period_name=Last%20year&var-repogroup_name=All)
  in the last year

## Maintainers

| Maintainer             | GitHub ID  | Affiliation | | ----------------------
| ---------- | ----------- | | Flavio Castelli        | @flavio    | SUSE
| | Victor Cuadrado Juan   | @viccuad   | SUSE        | | José Guilherme Vanz
| @jvanz     | SUSE        | | Rafael Fernández López | @ereslibre | VMWare
| | Fabrizio Sestito       | @fabriziosestito           |  SUSE           |

## Adoption

We haven’t set up an ADOPTERS.md file, so this is a difficult question. We know
about some companies doing evaluations and have seen policies being created by
the community. This is definitely an area of improvement for the project.

## Project performance

This is our first annual review. This year the goals of the project were to
deliver new features, increase awareness of and attract new contributors.

During the last year we delivered a steady stream of features, bug fixes and
improvements.

Our project’s profile has increased, and more people became aware of the
project. Joining CNCF, and adding our policies and components to ArtifactHub
were key factors. We have raised awareness about the project at conferences,
both as speakers and as members of booth crews. We have also seen
non-maintainers feature Kubewarden in other talks, which is encouraging.

There have been contributions from external developers this year, though
contributions have been, thus far, sporadic. We joined the Linux Foundation
mentorship program and this helped us increase the number of contributors.

## Goals

We plan to keep adding new features to the project, but also to work on these
areas:
- Improve our documentation: embrace the [Diataxis](https://diataxis.fr/) doc
  system, refresh the existing contents and begin to focus on user enablement
  as well as documenting features. These efforts will be led by a technical
  writer who recently joined our team
- Increase awareness of the project and attract new developers

## Incubation readiness

The Kubewarden project does not yet meet the criteria to move to incubation. We
intend to apply when the criteria have been met
