# Open Service Mesh (OSM) Annual Review 2021

## Project Overview

**[Open Service Mesh](https://openservicemesh.io)** is a simple, lightweight, extensible cloud native service mesh that allows users to uniformly manage, secure, and get out-of-the-box observability features for highly dynamic microservice environments.

## DevStats

> Include a link to your project’s devstats page. We will be looking for signs of consistent or increasing contribution activity. Please feel free to add commentary to add colour to the numbers and graphs we will see on devstats.

Open Service Mesh DevStats can be found [here](https://openservicemesh.devstats.cncf.io/d/8/dashboards?orgId=1&from=now-365d&to=now-1h).

## Maintainers

> How many maintainers do you have, and which organisations are they from? (Feel free to link to an existing MAINTAINERS file if appropriate.)

OSM currently has 15 [maintainers](https://github.com/openservicemesh/osm/blob/main/OWNERS).

- Delyan Raychev, Microsoft
- Eduardo Serra Miralles, VMware
- Kalya Subramanian, Microsoft
- Michelle Noorali, Independent
- Jon Huhn, Microsoft
- Shashank Ram, Microsoft
- Sanya Kochhar, Microsoft
- Shalier Xia, Microsoft
- Niranjan Shankar, Microsoft
- Sneha Chhabria, Microsoft
- Phillip Gibson, Microsoft
- Jackie Elliot, Microsoft
- Thomas Stringer, Microsoft
- Allen Leigh, Microsoft
- Rita Zhang, Microsoft

Beyond the maintainers list, OSM has had 64 unique [contributors](https://github.com/openservicemesh/osm/graphs/contributors) to the project. Over the past year there have been [10 contributing companies and up to 48 contributing developers](https://openservicemesh.devstats.cncf.io/d/7/companies-contributing-in-repository-groups?orgId=1&from=now-365d&to=now-1h&var-period=d28&var-repogroup_name=All).

## Adoption

> What do you know about adoption, and how has this changed since your last review / since you joined Sandbox? If you can list companies that are end users of your project, please do so. (Feel free to link to an existing ADOPTERS file if appropriate.)

Strong end-user adoption has grown since the OSM project entered into the sandbox stage. This adoption has made the OSM project pivot to supporting additional community projects collaborations/integrations such as [Flagger](https://github.com/fluxcd/flagger/blob/main/docs/gitbook/tutorials/osm-progressive-delivery.md), [Contour Ingress](https://release-v0-11.docs.openservicemesh.io/docs/demos/ingress_contour/), [Meshery](https://docs.meshery.io/service-meshes/adapters/osm) and [Open Policy Agent](https://release-v0-11.docs.openservicemesh.io/docs/guides/integrations/external_auth_opa/), with more in the works.

We continue to grow the community with providing our [Contributor Ladder](https://github.com/openservicemesh/osm/blob/main/CONTRIBUTOR_LADDER.md) to make it easy and clear to newcomers how to contribute and grow in status with the project.

There are currently over 100K+ pulls of the OSM controller image on [Docker Hub](https://hub.docker.com/r/openservicemesh/osm-controller), and community feedback has been positive for two CNCF sessions on [Securing your workload communications with OSM](https://www.youtube.com/watch?v=llC9gLznJX4) and [Simplifying service mesh operations with OSM](https://www.youtube.com/watch?v=fb80WmVVzH8).

## Project Performance

> How has the project performed against its goals since the last review? (We won't penalize you if your goals changed for good reasons.)

This is OSM's first CNCF project review. OSM's main project objectives have been centered on the following:

- Release version 1.0.0
- Delivering a simplified operators experience for service mesh operations
- Building a community that embodies the understanding and need for simple service mesh controls

The core OSM team believes we've made significant progress in these areas. We will soon be releasing version 1.0.0. The project will continue to engage with the community through the use of community calls, session videos, as well as interactions on issues posted to the GitHub repo.

## Project Goals

> What are the current goals of the project? For example, are you working on major new features? Or are you concentrating on adoption or documentation?

OSM has the following project goals:

- Release v1.0.0
- Enhance scalability and performance
- Grow project maintainers list
- Expand project functionality and capabilities (multi-cluster, additional compute runtimes, PKI, Service Mesh Interface APIs)

The OSM project also has a well defined [project road map](https://github.com/openservicemesh/osm/projects/3) with a list of initiatives for the project going forward.

## CNCF Collaboration

> How can the CNCF help you achieve your upcoming goals?

The OSM project has benefited from the partnership with the CNCF to host webinars to inform the community of the latest enhancements of the project. We look to continue to leverage the CNCF to assist in growing awareness of the project and providing community feedback on the project direction.

## Project Incubation Status

> Do you think that your project meets the criteria for incubation?

At this specific time of the annual review, the OSM project team believes we are close to beginning incubation stage talks after the v1.0.0 release has been available to users for a period of time. Incubation discussion will most likely start in the first half of calendar year 2022.
