*Name of project:* Operator Framework

*Description*

The third wave of Kubernetes applications is advanced distributed systems. These systems require active care and lifecycle management to function well. The tools within the Operator Framework aid developers when building, testing, publishing and updating these systems.

The Operator Framework expands the ecosystem of Kubernetes:

* Open source communities: helm, ansible, distributed databases like CockroachDB, distributed storage like Rook, distributed search engines like Elastic as well as many more tooling in the Kubernetes space like Aqua Security, Sisdig, Instana etc...
* Enterprises/users of Kubernetes: IT departments being internal providers of Kubernetes clusters, Corporate Developers, DevOps teams MongoDB, RedisLab, Cloud providers, Percona, CrunchyData...
* Software vendors: MongoDB, RedisLab, Cloud providers, Percona, CrunchyData

The Operator Framework provides essential features for distributed systems authors to build and run Operators:

* supports iterative development of Operators with integrated testing
* packaging and distribution concept of Operators
* a central point of authority of Operators on cluster
* declarative way of instantiating Operators
* lifecycle handling of long running Operators with regards to upgrades, versioning & dependencies 


*Statement on alignment with CNCF mission*:

The Operator Framework expands the Kubernetes ecosystem to empower users with an easy and robust mechanism to run advanced distributed systems. These distributed systems are frequently other CNCF projects like Prometheus, Jaeger, etcd, Rook, NATS and more. The Bringing the Operator Framework into the CNCF will strengthen these relationships and allow users to adopt and run these CNCF projects in production.

*Sponsor / Advisor from TOC*: Katie Gamanji

*Unique identifier:* operator-framework

*Preferred Maturity Level*: incubating

*License*: Apache License v2.0

*Source control repositories*: link:https://github.com/operator-framework[GitHub]

*External dependencies*

_(Runtime dependencies only)_


*Infrastructure requirements*: 

* CI (currently use TravisCI)

*Communication Channels*:

* Mailing List: https://groups.google.com/d/forum/operator-framework _(A public Google Group. Move to CNCF Mailing Lists should be considered if the Operator Framework is accepted.)_

*Website*: https://github.com/operator-framework[Github Organization]

*Release methodology and mechanics*

Releases are done through...

*Community size and existing sponsorship*:

_(12/July/2019)_

* GitHub Stars (SDK): 2449
* GitHub Stars (OLM): 439
* GitHub Forks (SDK): 634
* GitHub Forks (OLM): 182
* GitHub Code Contributors (SDK): 117
* GitHub Code Contributors (OLM): 72
* Slack users: 1409
* Mailing list subscribers: 585

* Existing Sponsors:
  * Red Hat (10-15 people working full-time)
  
We hope that by bringing the Operator Framework project under the CNCF umbrella as a neutral host, we will be able to further expand the development community and the further expand the adoption of the project.
Website: https://operatorhub.io/
GitHub: https://github.com/operator-framework
License: Apache License, Version 2.0
