# Technical Leadership Principles Enforcement Process

This document serves as a guide for occasions where the Code of Conduct Committee or another entity informs the TOC of a technical leader who is allegedly infringing on or in violation of the technical leadership principles.

## Background

The **[technical leadership principles](https://github.com/cncf/toc/blob/main/PRINCIPLES.md#technical-leadership-principles)** were developed during the creation of the CNCF Code of Conduct Committee to establish the standard of excellence among leaders in our Groups, Committees, and Projects. They were subsequently approved by the TOC for inclusion in the CNCF TOC Principles.

The harm and erosion of trust that can occur as a lack of embodiment of these principles detrimentally degrades our projects, groups, and communities. 

Where Code of Conduct violations impact one or more individuals directly, lack of adherence to the leadership principles impact the Project, the Group, and the community.

## Expectations for projects and groups

As with all things, [Projects and our groups are Self-governing](https://github.com/cncf/toc/blob/main/PRINCIPLES.md#projects-are-self-governing) towards the governance outcomes defined and expected by the TOC.

It is in this spirit of our operating principles that the TOC expects all projects, groups, and community bodies to self-enforce adherence to the Technical Leadership Principles. We further expect each project, group, and body to respectfully and reasonably address any behavior by an individual that is not in alignment with the Technical Leadership Principles prior to escalating to the TOC for resolution. Among the TOC, escalation is to the TOC Chair and Vice Chair. 

## Escalating to the TOC

In the event that the project or group cannot resolve this conflict with the resources available to them, the project should escalate to the TOC through the private mailing list where the TOC Chair, Vice Chair, or CNCF Staff who will triage.

To escalate to the TOC, please email: cncf-private-toc@lists.cncf.io 

If the escalation concerns a current TOC member, please contact the TOC Chair, Vice Chair, and/or CNCF Staff directly.

Once escalated, the TOC Chair and/or Vice Chair will assign two TOC members to guide and mentor the project or group and its leadership on methods and options to arrive at an agreeable resolution. Resolutions are crafted to allow for the best outcome for the project or group and its future. The TOC may suggest changes among the leadership roles, responsibilities, and project governance to support that outcome.

## Additional Information and Guidance

### Conflict is likely

Innovation is often born from the diversity of opinion, perspective, and experience of individuals collaborating towards a common goal or objective. Fostering an engaging and exploratory discussion, debate, and exchange of ideas to drive innovation requires a foundation of respect, grace, and curiosity so all voices may be elevated, heard, and incorporated into the discussion.

Navigating conflict within a project or group to a positive resolution is achievable, even with different backgrounds and perspectives involved. The project or group's leadership is responsible for developing a culture of understanding and respect through the example they set. When conflict does occur, finding a root of agreement to begin building consensus around the problem space is essential before moving on to a solution. Many individuals come to a problem, or perceived problem, with a solution or implementation in hand, often fixated as the correct path forward. As leader, encouraging individuals to set aside their predisposed ideas allows for the group to discover a solution together.

### Building and breaking trust

Leadership creates a power imbalance and in our community this imbalance is offset through an individuals’ ability to positively influence contributors to collaborate towards agreed outcomes. Our nomination and voting process for filling leadership roles in our groups, projects, or committees) is rooted in the merits of an individual’s work and the trust built as a result of their behaviors and community engagement. It is that trust that allows for positive influence to occur to offset any negative harm that could occur due to such an imbalance of power.

When an individual's behavior fails to embody our principles and values and/or their personal/private views are exposed to the community, it has the potential to subversively abuse that imbalance and negatively harm the project and its community. A leader’s behavior and views has the singular ability to build or break our projects and our community; undermining trust of the leader holding them because those personal views may not align with CNCF values and may be seen to promote intolerance. Individuals have a right to their personal, private perspectives, but as leaders in our community we are expected to embody and practice the technical leadership principles and uphold our Code of Conduct through our behavior and engagements, serving as the arbiter of equity and fairness within projects, within the community, within CNCF spaces, and at CNCF events. 

### Prevention

All projects, groups, and committees are expected to establish a policy or governance process that allows for the removal of a leader for failure to continually align with our principles and values through a vote of no confidence after attempts to constructively correct (restorative justice) have occurred. [TAG Contributor Strategy even has a template to cover this, projects and groups are encouraged to adopt it](https://github.com/cncf/project-template/blob/main/CONTRIBUTOR_LADDER.md#involuntary-removal-or-demotion) or refer to the [Kubernetes project's Charter, which has a section on removal](https://github.com/kubernetes/steering/blob/main/charter.md#removal). It is unrealistic to detail every possible offense or behavior that could warrant such action and each project may have additional considerations to evaluate as part of determining the need for a vote of no confidence. 

These prevention guidelines will be codified into a future revision of the moving levels criteria regarding appropriate project governance.

## Resources

We want to hear from you! These resources are available for the community to add to, especially if they found it useful. To add a resource, please file a PR. TOC members reviewing PRs for adding content must review the material in its entirety prior to approving.

### Training

#### No cost

* Inclusive Strategies for open source https://training.linuxfoundation.org/training/inclusive-strategies-for-open-source-lfc103/ 
* Inclusive Speaker orientation https://training.linuxfoundation.org/training/inclusive-speaker-orientation/ 
  * While focused on Speaking, this training provides tips to help you check assumptions in your content and its delivery. 

### Past talks

* _please suggest talks on this topic here_

### Community content

* [Technical Mediation](https://github.com/TheFoxAtWork/Technical-Leadership/tree/main/technical-mediation), @TheFoxAtWork - how to resolve technical conflicts collaboratively. 
* [Patience and Listening](https://github.com/TheFoxAtWork/Technical-Leadership/tree/main/patience-listening), @TheFoxAtWork - understanding how to be patient and actively listen during a conflict to be supportive while reaching resolution.
